; aWorm v1.0
;
; Don't send this program to a TI 82 with ROM 19.006
; because some addresses are here for the 19.0 and they will
; crash a 19.006  :-(  ::BE CAREFUL::

; -pacHa [pacha07@caramail.com] 28/10/2002

; thanks to Dines Justesen for his graphic routines


.include	acebeta.inc

.db	$CD,"aWorm",6,"v1.0",0

FIND_PIXEL	=	$4166				; I had to define this address in the ROM because it's not implemented
							; in ACE beta 4. 

pos_x		=	SH_BUF		; byte
pos_y		=	SH_BUF + 1		; byte
direction	=	SH_BUF + 2		; byte
score		=	SH_BUF + 3		; word
mines		=	SH_BUF + 5 		; word

	CALL	CLEARLCD

	ld	a,$8c					; ROM page to 4
	out	(2),a					; for graphic ops.


	ld	b,96					; Draws the vertical lines
vertical:
	ld	c,0
	call	Point_on
	ld	c,62
	call	Point_on
	djnz	vertical

	ld	c,62					; Draws the horizontal lines
horizontal:
	ld	b,0
	call	Point_on
	ld	b,95
	call	Point_on
	dec	c
	jr	nz,horizontal
	call	Point_on

	ld	hl,$0000
	ld	(mines),hl
	ld	(score),hl


loopstart:						;
	CALL	RAND					;
	cp	96					;
	jr	nc,loopstart			; Routine that draws randomly points on the srceen
	ld	b,a					; until a key is pressed. The number of points is
loopstart2:						; stored into (mines) and if [0] is pressed, the
	CALL	RAND					; highscore is reset.
	cp	61					; Written by me !
	jr	nc,loopstart2			;
	ld	c,a					;
	call	Point_on				;
	ld	hl,(mines)				;
	inc	hl					;
	ld	(mines),hl				;
	CALL	GETKEY				;
	cp	G_0					;
	jp	z,reset_high			;
	cp	0					;
	jr	z,loopstart				;


apres_points:
	ld	a,1
	ld	(direction),a
	ld	(pos_x),a				; x start

	ld	a,$3d					; y start
	ld	(pos_y),a

loop:

	ld	hl,(score)
	inc	hl
	ld	(score),hl

	CALL	GETKEY
	cp	G_RIGHT
	jr	z,dir_plus
	cp	G_LEFT
	jr	z,dir_moins
	cp	G_CLEAR
	jp	z,EXIT_TIOS

	jr	suite

suite:

	ld	a,(direction)
	cp	1
	jr	z,droite
	cp	2
	jr	z,bas
	cp	3
	jr	z,gauche

	ld	a,(pos_y)
	inc	a
	ld	(pos_y),a

suite2:
	ld	a,(pos_x)
	ld	b,a

	ld	a,(pos_y)
	ld	c,a

	call	GetPixel
	jr	nz,fin

	call	Point_on

;------------------------------------------------;
;	ld	b,3			; slowing routine	 ; This routine is not used in this version but
;slow:							 ; the speed may be selected in next release, and
;	halt							 ; this routine will be useful for this.
;	djnz	slow						 ;
;------------------------------------------------;

	halt
	halt
	halt

	jr	loop

dir_plus:
	ld	a,(direction)
	cp	4
	jr	z,un
	inc	a
	ld	(direction),a
	jr	suite

dir_moins:
	ld	a,(direction)
	cp	1
	jr	z,quatre
	dec	a
	ld	(direction),a
	jr	suite

un:
	ld	a,1
	ld	(direction),a
	jr	suite

quatre:
	ld	a,4
	ld	(direction),a
	jr	suite

droite:
	ld	a,(pos_x)
	inc	a
	ld	(pos_x),a
	jr	suite2

bas:
	ld	a,(pos_y)
	dec	a
	ld	(pos_y),a
	jr	suite2

gauche:
	ld	a,(pos_x)
	dec	a
	ld	(pos_x),a
	jr	suite2

fin:
	CALL	CLEARLCD

	ld	hl,$0000
	ld	(CURSOR_POS),hl
	ld	hl,txt_fin1
	CALL	D_ZT_STR

	ld	hl,(score)
	CALL	$3896			; D_HL_DECI

	ld	hl,$0001
	ld	(CURSOR_POS),hl
	ld	hl,txt_fin2
	CALL	D_ZT_STR

	ld	hl,(mines)
	CALL	$3896			; D_HL_DECI

	ld	hl,$0303
	ld	(CURSOR_POS),hl
	set	3,(iy+05)		; inversed text
	ld	hl,txt_fin3
	CALL	D_ZT_STR

	ld	hl,(score)
	ld	de,(mines)
	add	hl,de
	ld	(score),hl
	CALL	$3896

	res	3,(iy+05)		; normal text

	ld	hl,$0006
	ld	(CURSOR_POS),hl
	ld	hl,txt_fin4
	CALL	D_ZT_STR

	ld	hl,(highscore)
	CALL	$3896

	ld	hl,(score)
	ld	de,(highscore)
	CALL	CP_HL_DE
	call	nc,new_high

	CALL	PAUSE
	ret


txt_fin1:
	.db	"Pixels",0
txt_fin2:
	.db	"Mines",0
txt_fin3
	.db	"Score",0
txt_fin4:
	.db	"Highscore",0
txt_fin5:
	.db	"New highscore!",0
highscore:
	.dw	0

new_high:
	ld	(highscore),hl
	ld	hl,$0005
	ld	(CURSOR_POS),hl
	ld	hl,txt_fin5
	CALL	D_ZT_STR
	ret

reset_high:
	ld	hl,$0000
	ld	(highscore),hl
	jp	apres_points
	

;________________________________Graphic routines written by Dines Justesen
;________________________________taken from GRAPH.inc and modified by me.
; Thanks for his work

GetPixel:
	PUSH BC
        CALL FIND_PIXEL ; HL=byte offset in video buffer, A=2^(bit to change)
        LD B,A
        LD A,($8011)        ; Goto line
        OUT ($10),A
        LD A,($800F)        ; Goto byte
        OUT ($10),A
        IN A,($11)
	IN A,($11)
        AND B               ; Mask, so only one pixel left
        POP BC
        RET

Point_on:
	PUSH BC
        CALL FIND_PIXEL
        LD B,A
        LD A,($8011)        ; Goto line
        OUT ($10),A
        LD A,($800F)        ; Goto byte
        OUT ($10),A
        halt
        IN A,($11)          ; Get byte
	IN A,($11)
        OR B                ; Set pixel
        LD B,A
        LD A,($8011)        ; Goto line
        OUT ($10),A
        LD A,($800F)        ; Goto byte
        OUT ($10),A
        LD A,B
        OUT ($11),A
        POP BC
	RET

;______________________________
;______________________________

.end